var gulp = require('gulp');
var connect = require('gulp-connect-php');
var _ = require('underscore');
var browserSync = require('browser-sync').create();
var path = require('path');
var Elixir = require('laravel-elixir');

Elixir.extend('elixirConnect', function (config) {
    if (config) {
        config = _.extend({
            hostname: '127.0.0.1',
            port: 8000,
            base: './public',
            keepalive: true,
            browserSync: false
        }, config);

        if (config.browserSync) {
            config.browserSync = _.extend({
                proxy: config.hostname + ':' + config.port,
                open: true,
                notify: true,
                reloadOnRestart: true,
                files: [
                    path.join(Elixir.config.appPath, '**/*.php'),
                    path.join(Elixir.config.publicPath + "/" + Elixir.config.css.folder, '**/*.css'),
                    path.join(Elixir.config.publicPath + "/" + Elixir.config.js.folder, '**/*.js'),
                    'resources/views/**/*.*'
                ]
            }, config.browserSync);

        }
    }

    new Elixir.Task('elixirConnect', function () {
        connect.server(config);
        if (config && config.browserSync) {
            if (!browserSync.active) {
                browserSync.init(config.browserSync);
            }
        }
    }).watch('./app/**');
});